/*********************************************************************
(C) Copyright 1989        Franklin L. DeRemer,	 Thomas J. Pennello,
			 MetaWare Incorporated;  Santa Cruz, CA 95060.
This program is the unpublished property and trade secret of the above
three.	It is to be utilized solely under license from MetaWare and it
is to be maintained on a confidential basis for internal  company  use
only.  The  security  and  protection  of  the program is paramount to
maintenance of the trade secret status.  It is to  be  protected  from
disclosure  to	unauthorized parties, both within the Licensee company
and outside, in a manner not less stringent than that utilized for Li-
censee's own proprietary  internal  information.   No  copies  of  the
Source or Object Code are to leave the premises of Licensee's business
except	in  strict accordance with the license agreement signed by Li-
censee with MetaWare.
*********************************************************************/ 

#include <stdio.h>

/* Here initialize the _iob structure and specify its size.
 * This allows any programmer to increase the number of iob entries
 * (up to a maximum of 255, since _fd in the _iob is a 1-byte entry.
 */

/* Decide on your own limit here, 
 * and then optionally change FOPEN_MAX in stdio.h.
 */

#define IOB_LIMIT FOPEN_MAX

_iobuf _iob[IOB_LIMIT] = {
   {0,0,0,_READING|_UNINITIALIZED,0/*stdin */,},     /* 0 */
   {0,0,0,_WRITING|_UNINITIALIZED,1/*stdout*/,},    /* 1 */
   {0,0,0,_WRITING|_UNINITIALIZED,2/*stderr*/,},    /* 2 */
   /* These are not necessary for DOS, but for other OMF systems in which
    * the linker/loader does not set unitialized data to 0,
    * these lines are necessary to initialize _flag and _cnt.
    */
#define Z {0,0,0,0,},   /* _flag and _cnt are set to zero */
   Z Z Z Z Z Z Z 	/* 3..9 */
   Z Z Z Z Z Z Z Z Z Z 	/* 10..19 */
   Z Z Z Z Z 		/* 20..24 */
   };
#undef Z

unsigned _bufsiz[IOB_LIMIT] = {
#define Z 0,	
   Z Z Z Z Z Z Z Z Z Z  /* 0..9 */
   Z Z Z Z Z Z Z Z Z Z  /* 10..19 */
   Z Z Z Z Z            /* 20..24 */
   };
#undef Z
	
pragma off(public_var_warnings);
int _fopen_max = sizeof(_iob)/sizeof(_iob[0]); 

void * _temp_file_chain = 0;    /* For tmpnam, tmpfile. */